#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20101229

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)


#ifndef yyparse
#define yyparse    dvdvmparse
#endif /* yyparse */

#ifndef yylex
#define yylex      dvdvmlex
#endif /* yylex */

#ifndef yyerror
#define yyerror    dvdvmerror
#endif /* yyerror */

#ifndef yychar
#define yychar     dvdvmchar
#endif /* yychar */

#ifndef yyval
#define yyval      dvdvmval
#endif /* yyval */

#ifndef yylval
#define yylval     dvdvmlval
#endif /* yylval */

#ifndef yydebug
#define yydebug    dvdvmdebug
#endif /* yydebug */

#ifndef yynerrs
#define yynerrs    dvdvmnerrs
#endif /* yynerrs */

#ifndef yyerrflag
#define yyerrflag  dvdvmerrflag
#endif /* yyerrflag */

#ifndef yylhs
#define yylhs      dvdvmlhs
#endif /* yylhs */

#ifndef yylen
#define yylen      dvdvmlen
#endif /* yylen */

#ifndef yydefred
#define yydefred   dvdvmdefred
#endif /* yydefred */

#ifndef yydgoto
#define yydgoto    dvdvmdgoto
#endif /* yydgoto */

#ifndef yysindex
#define yysindex   dvdvmsindex
#endif /* yysindex */

#ifndef yyrindex
#define yyrindex   dvdvmrindex
#endif /* yyrindex */

#ifndef yygindex
#define yygindex   dvdvmgindex
#endif /* yygindex */

#ifndef yytable
#define yytable    dvdvmtable
#endif /* yytable */

#ifndef yycheck
#define yycheck    dvdvmcheck
#endif /* yycheck */

#ifndef yyname
#define yyname     dvdvmname
#endif /* yyname */

#ifndef yyrule
#define yyrule     dvdvmrule
#endif /* yyrule */
#define YYPREFIX "dvdvm"

#define YYPURE 0

#line 2 "dvdvmy.y"

/*
 * Copyright (C) 2002 Scott Smith (trckjunky@users.sourceforge.net)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include "compat.h" /* needed for bool */
#include "dvdvm.h"


#define YYERROR_VERBOSE

#line 92 "dvdvmy.y"
#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
typedef union {
    unsigned int int_val;
    char *str_val;
    struct vm_statement *statement;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 139 "dvdvmy.c"
/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#define YYERROR_DECL() yyerror(const char *s)
#define YYERROR_CALL(msg) yyerror(msg)

extern int YYPARSE_DECL();

#define NUM_TOK 257
#define G_TOK 258
#define S_TOK 259
#define ID_TOK 260
#define ANGLE_TOK 261
#define AUDIO_TOK 262
#define BREAK_TOK 263
#define BUTTON_TOK 264
#define CALL_TOK 265
#define CELL_TOK 266
#define CHAPTER_TOK 267
#define CLOSEBRACE_TOK 268
#define CLOSEPAREN_TOK 269
#define COUNTER_TOK 270
#define ELSE_TOK 271
#define ENTRY_TOK 272
#define EXIT_TOK 273
#define FPC_TOK 274
#define GOTO_TOK 275
#define IF_TOK 276
#define JUMP_TOK 277
#define LAST_TOK 278
#define MENU_TOK 279
#define NEXT_TOK 280
#define OPENBRACE_TOK 281
#define OPENPAREN_TOK 282
#define PGC_TOK 283
#define PREV_TOK 284
#define PROGRAM_TOK 285
#define PTT_TOK 286
#define REGION_TOK 287
#define RESUME_TOK 288
#define RND_TOK 289
#define ROOT_TOK 290
#define SET_TOK 291
#define SUBTITLE_TOK 292
#define TAIL_TOK 293
#define TITLE_TOK 294
#define TITLESET_TOK 295
#define TOP_TOK 296
#define UP_TOK 297
#define VMGM_TOK 298
#define _OR_TOK 299
#define XOR_TOK 300
#define LOR_TOK 301
#define BOR_TOK 302
#define _AND_TOK 303
#define LAND_TOK 304
#define BAND_TOK 305
#define NOT_TOK 306
#define EQ_TOK 307
#define NE_TOK 308
#define GE_TOK 309
#define GT_TOK 310
#define LE_TOK 311
#define LT_TOK 312
#define ADD_TOK 313
#define SUB_TOK 314
#define MUL_TOK 315
#define DIV_TOK 316
#define MOD_TOK 317
#define ADDSET_TOK 318
#define SUBSET_TOK 319
#define MULSET_TOK 320
#define DIVSET_TOK 321
#define MODSET_TOK 322
#define ANDSET_TOK 323
#define ORSET_TOK 324
#define XORSET_TOK 325
#define SEMICOLON_TOK 326
#define COLON_TOK 327
#define ERROR_TOK 328
#define YYERRCODE 256
static const short dvdvmlhs[] = {                        -1,
    0,    1,    1,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,   10,   10,   10,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   12,   12,    4,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,   13,   13,   14,   14,    3,   15,   15,
   15,   15,   15,   15,   15,   16,   16,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
    9,    9,   17,   17,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    6,    7,    7,
};
static const short dvdvmlen[] = {                         2,
    1,    1,    2,    1,    1,    2,    2,    3,    2,    2,
    1,    3,    1,    2,    1,    0,    2,    1,    3,    3,
    3,    3,    3,    3,    1,    2,    0,    2,    0,    5,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    2,    0,    2,    0,    7,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    3,    1,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    4,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    2,    1,    2,    4,    4,    4,    4,    4,    4,
    4,    4,    4,    5,    1,    3,
};
static const short dvdvmdefred[] = {                      0,
   49,   50,    0,   53,   51,    0,   54,    0,    0,    0,
    0,    0,    0,    0,   55,    0,   52,    0,    1,    0,
    5,    4,   11,    0,   13,    0,    0,    9,   10,    0,
   15,    0,   84,    6,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    7,    3,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   14,   25,    0,    0,
    0,    8,   57,    0,    0,    0,    0,    0,   56,   59,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   12,   96,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   17,    0,   26,    0,
    0,    0,    0,    0,   82,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   31,   33,   34,   40,
   37,   43,   39,   35,   41,   38,   32,   36,   42,    0,
    0,   86,   87,   88,   89,   90,   91,   92,   93,   85,
   23,   22,   24,   20,   21,   19,   28,    0,    0,   58,
   71,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   62,   63,   64,   94,    0,
    0,   81,   79,   30,   44,    0,    0,   70,   46,   48,
};
static const short dvdvmdgoto[] = {                      18,
   19,   20,   21,   22,   23,   24,   25,   67,   68,   32,
   61,  101,  159,  187,   69,   70,   27,
};
static const short dvdvmsindex[] = {                    197,
    0,    0, -317,    0,    0, -314,    0, -224, -237, -289,
 -209, -183,  203,  197,    0, -205,    0,    0,    0,  197,
    0,    0,    0, -147,    0,  379, -164,    0,    0, -135,
    0, -259,    0,    0, -195,   74, -251, -207, -170, -148,
 -241, -151, -259, -134,    0,    0,  197,  156,  156,  156,
  156,  156,  156,  156,  156,  156,    0,    0, -199, -121,
 -128,    0,    0,   74, -144,   74,  363, -265,    0,    0,
 -180, -160, -159, -157, -142, -141, -140, -139, -132, -131,
 -130, -113, -112, -128,    0,    0,  156,  191,  210,  229,
  248,  267,  286,  305,  324,  343,    0,  185,    0,  -42,
  -72,   76,  -57,  156,    0,  156,  156,  156,  156,  156,
  156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
  156,  197,   74,   74,   74,   74,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -109,
  -64,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -35,  -54,    0,
    0,   95,  378,  378,  378, -124, -124, -172, -172, -172,
 -172, -172, -172, -168, -168,    0,    0,    0,    0, -243,
 -243,    0,    0,    0,    0,  -46,  -94,    0,    0,    0,
};
static const short dvdvmrindex[] = {                      0,
    0,    0,    0,    0,    0,    0,    0, -226,    0,    0,
    0,    0, -225,    0,    0,    0,    0,    0,    0,    2,
    0,    0,    0,    1,    0,  -51,    0,    0,    0,    0,
    0, -245,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -256,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -169,    0,
 -270,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -314,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -269,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -92,    0,
    0,    0,  -81,   -2,   18, -129, -101,   12,   54,   68,
  127,  133,  150, -197, -149,    0,    0,    0,    0, -255,
 -222,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
static const short dvdvmgindex[] = {                      0,
   -1,  -47,    0,    0,    0,    0,    0,  -24,  -59,  224,
  200,  164,    0,    0,    3,    0,    0,
};
#define YYTABLESIZE 704
static const short dvdvmtable[] = {                      86,
   95,    2,   26,  122,  103,   71,  105,   29,   45,   28,
   27,   29,   44,   80,   58,   81,   26,   29,   46,   59,
   33,   27,   26,   88,   89,   90,   91,   92,   93,   94,
   95,   96,   27,  123,   60,  124,   34,  125,  126,  102,
   16,   16,   27,   80,   72,   80,   78,   16,   16,   26,
   35,   16,   16,   16,   82,   29,   45,   97,   73,  125,
  126,   16,  141,  180,  181,  182,  183,   16,   16,   27,
   30,   60,   98,   31,  179,   74,   78,   75,   78,  162,
   27,  163,  164,  165,  166,  167,  168,  169,  170,  171,
  172,  173,  174,  175,  176,  177,  178,   18,   36,   16,
   16,   60,   60,   60,   60,   60,   60,   60,   18,   60,
   60,   60,   60,   60,   60,   60,   60,   78,   18,   61,
   45,   57,   76,   47,   26,   77,   56,  107,   60,  108,
   62,   83,  110,   85,   79,   99,   80,  104,  100,   67,
  117,  118,  119,  120,  121,  127,  119,  120,  121,   61,
   61,   61,   61,   61,   61,   61,   18,   61,   61,   61,
   61,   61,   61,   61,   61,  128,  129,   65,  130,   67,
   67,   67,   67,   67,   67,   67,   61,   67,   67,   67,
   67,   67,   67,  131,  132,  133,  134,   68,  117,  118,
  119,  120,  121,  135,  136,  137,   67,   65,   65,   65,
   65,   65,   65,   65,  160,   65,   65,   65,   65,   65,
   65,  161,  138,  139,  157,  158,  184,   68,   68,   68,
   68,  185,   68,  186,   65,   68,   68,   68,   68,   68,
   68,  190,  189,   47,  106,  107,   43,  108,  109,   83,
  110,  123,   84,  124,   68,  125,  126,  140,  117,  118,
  119,  120,  121,    0,    0,    0,    0,    0,   95,   95,
   95,   95,   95,   95,   95,   95,   69,    0,   95,    2,
   95,    0,    0,   95,    0,   95,   95,   95,    0,    0,
   72,   95,    0,    0,    0,    0,   66,   95,   95,    0,
    0,    0,   95,    0,    0,    0,   69,   69,   69,   69,
    0,   69,    0,    0,   69,   69,   69,   69,   69,   69,
   72,    0,   72,    0,   72,   72,   66,   66,   66,   66,
    0,   66,   73,   69,   66,   66,   66,   66,   66,   66,
   63,    1,    2,    0,    4,    5,   74,    7,    0,    0,
    0,    0,    0,   66,  160,    0,    0,    0,    0,    0,
    0,    0,   73,    0,   73,   64,   73,   73,    0,    0,
   15,    0,   65,  188,    0,   17,   74,    0,   74,    0,
   74,   74,    0,    0,  106,  107,    0,  108,  109,   66,
  110,    0,  111,  112,  113,  114,  115,  116,  117,  118,
  119,  120,  121,  106,  107,   75,  108,  109,    0,  110,
    0,   76,    0,    0,    0,    0,    0,  117,  118,  119,
  120,  121,   63,    1,    2,    0,    4,    5,   77,    7,
    0,    0,    0,    0,    0,   75,    0,   75,    0,   75,
   75,   76,    0,   76,    0,   76,   76,   87,    0,    0,
    0,    0,   15,    0,   65,  151,  152,   17,   77,    0,
   77,    0,   77,   77,    1,    2,    3,    4,    5,    6,
    7,    8,    0,    0,    0,    0,    9,    0,   37,   10,
  153,   11,   12,   13,  154,    0,  155,   14,  156,    0,
    0,    0,   38,   15,   16,   39,   40,   41,   17,  106,
  107,    0,  108,  109,    0,  110,    0,   30,    0,   42,
   31,    0,    0,  117,  118,  119,  120,  121,  106,  107,
    0,  108,  109,    0,  110,    0,  142,    0,    0,    0,
    0,    0,  117,  118,  119,  120,  121,  106,  107,    0,
  108,  109,    0,  110,    0,  143,    0,    0,    0,    0,
    0,  117,  118,  119,  120,  121,  106,  107,    0,  108,
  109,    0,  110,    0,  144,    0,    0,    0,    0,    0,
  117,  118,  119,  120,  121,  106,  107,    0,  108,  109,
    0,  110,    0,  145,    0,    0,    0,    0,    0,  117,
  118,  119,  120,  121,  106,  107,    0,  108,  109,    0,
  110,    0,  146,    0,    0,    0,    0,    0,  117,  118,
  119,  120,  121,  106,  107,    0,  108,  109,    0,  110,
    0,  147,    0,    0,    0,    0,    0,  117,  118,  119,
  120,  121,  106,  107,    0,  108,  109,    0,  110,    0,
  148,    0,    0,    0,    0,    0,  117,  118,  119,  120,
  121,  106,  107,    0,  108,  109,    0,  110,    0,  149,
    0,    0,    0,    0,    0,  117,  118,  119,  120,  121,
    0,  106,  107,    0,  108,  109,    0,  110,  150,  111,
  112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
  109,    0,  110,    0,    0,    0,    0,    0,    0,    0,
  117,  118,  119,  120,  121,    0,   48,   49,   50,   51,
   52,   53,   54,   55,
};
static const short dvdvmcheck[] = {                      47,
    0,    0,    0,  269,   64,  257,   66,  278,  278,  327,
  267,  326,   14,  269,  274,  257,   14,  288,   20,  279,
  258,  267,   20,   48,   49,   50,   51,   52,   53,   54,
   55,   56,  278,  299,  294,  301,  326,  303,  304,   64,
  267,  267,  288,  299,  296,  301,  269,  274,  274,   47,
  260,  278,  279,  279,  296,  326,  326,  257,  266,  303,
  304,  288,   87,  123,  124,  125,  126,  294,  294,  326,
  295,  269,  272,  298,  122,  283,  299,  285,  301,  104,
  326,  106,  107,  108,  109,  110,  111,  112,  113,  114,
  115,  116,  117,  118,  119,  120,  121,  267,  282,  326,
  326,  299,  300,  301,  302,  303,  304,  305,  278,  307,
  308,  309,  310,  311,  312,  313,  314,  266,  288,  269,
  326,  257,  293,  271,  122,  296,  291,  300,  326,  302,
  326,  283,  305,  268,  283,  257,  285,  282,  267,  269,
  313,  314,  315,  316,  317,  326,  315,  316,  317,  299,
  300,  301,  302,  303,  304,  305,  326,  307,  308,  309,
  310,  311,  312,  313,  314,  326,  326,  269,  326,  299,
  300,  301,  302,  303,  304,  305,  326,  307,  308,  309,
  310,  311,  312,  326,  326,  326,  326,  269,  313,  314,
  315,  316,  317,  326,  326,  326,  326,  299,  300,  301,
  302,  303,  304,  305,  269,  307,  308,  309,  310,  311,
  312,  269,  326,  326,  257,  288,  326,  299,  300,  301,
  302,  257,  304,  278,  326,  307,  308,  309,  310,  311,
  312,  326,  279,  326,  299,  300,   13,  302,  303,  291,
  305,  299,   43,  301,  326,  303,  304,   84,  313,  314,
  315,  316,  317,   -1,   -1,   -1,   -1,   -1,  258,  259,
  260,  261,  262,  263,  264,  265,  269,   -1,  268,  268,
  270,   -1,   -1,  273,   -1,  275,  276,  277,   -1,   -1,
  269,  281,   -1,   -1,   -1,   -1,  269,  287,  288,   -1,
   -1,   -1,  292,   -1,   -1,   -1,  299,  300,  301,  302,
   -1,  304,   -1,   -1,  307,  308,  309,  310,  311,  312,
  299,   -1,  301,   -1,  303,  304,  299,  300,  301,  302,
   -1,  304,  269,  326,  307,  308,  309,  310,  311,  312,
  257,  258,  259,   -1,  261,  262,  269,  264,   -1,   -1,
   -1,   -1,   -1,  326,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  299,   -1,  301,  282,  303,  304,   -1,   -1,
  287,   -1,  289,  269,   -1,  292,  299,   -1,  301,   -1,
  303,  304,   -1,   -1,  299,  300,   -1,  302,  303,  306,
  305,   -1,  307,  308,  309,  310,  311,  312,  313,  314,
  315,  316,  317,  299,  300,  269,  302,  303,   -1,  305,
   -1,  269,   -1,   -1,   -1,   -1,   -1,  313,  314,  315,
  316,  317,  257,  258,  259,   -1,  261,  262,  269,  264,
   -1,   -1,   -1,   -1,   -1,  299,   -1,  301,   -1,  303,
  304,  299,   -1,  301,   -1,  303,  304,  282,   -1,   -1,
   -1,   -1,  287,   -1,  289,  261,  262,  292,  299,   -1,
  301,   -1,  303,  304,  258,  259,  260,  261,  262,  263,
  264,  265,   -1,   -1,   -1,   -1,  270,   -1,  266,  273,
  286,  275,  276,  277,  290,   -1,  292,  281,  294,   -1,
   -1,   -1,  280,  287,  288,  283,  284,  285,  292,  299,
  300,   -1,  302,  303,   -1,  305,   -1,  295,   -1,  297,
  298,   -1,   -1,  313,  314,  315,  316,  317,  299,  300,
   -1,  302,  303,   -1,  305,   -1,  326,   -1,   -1,   -1,
   -1,   -1,  313,  314,  315,  316,  317,  299,  300,   -1,
  302,  303,   -1,  305,   -1,  326,   -1,   -1,   -1,   -1,
   -1,  313,  314,  315,  316,  317,  299,  300,   -1,  302,
  303,   -1,  305,   -1,  326,   -1,   -1,   -1,   -1,   -1,
  313,  314,  315,  316,  317,  299,  300,   -1,  302,  303,
   -1,  305,   -1,  326,   -1,   -1,   -1,   -1,   -1,  313,
  314,  315,  316,  317,  299,  300,   -1,  302,  303,   -1,
  305,   -1,  326,   -1,   -1,   -1,   -1,   -1,  313,  314,
  315,  316,  317,  299,  300,   -1,  302,  303,   -1,  305,
   -1,  326,   -1,   -1,   -1,   -1,   -1,  313,  314,  315,
  316,  317,  299,  300,   -1,  302,  303,   -1,  305,   -1,
  326,   -1,   -1,   -1,   -1,   -1,  313,  314,  315,  316,
  317,  299,  300,   -1,  302,  303,   -1,  305,   -1,  326,
   -1,   -1,   -1,   -1,   -1,  313,  314,  315,  316,  317,
   -1,  299,  300,   -1,  302,  303,   -1,  305,  326,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  303,   -1,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  313,  314,  315,  316,  317,   -1,  318,  319,  320,  321,
  322,  323,  324,  325,
};
#define YYFINAL 18
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 328
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"NUM_TOK","G_TOK","S_TOK",
"ID_TOK","ANGLE_TOK","AUDIO_TOK","BREAK_TOK","BUTTON_TOK","CALL_TOK","CELL_TOK",
"CHAPTER_TOK","CLOSEBRACE_TOK","CLOSEPAREN_TOK","COUNTER_TOK","ELSE_TOK",
"ENTRY_TOK","EXIT_TOK","FPC_TOK","GOTO_TOK","IF_TOK","JUMP_TOK","LAST_TOK",
"MENU_TOK","NEXT_TOK","OPENBRACE_TOK","OPENPAREN_TOK","PGC_TOK","PREV_TOK",
"PROGRAM_TOK","PTT_TOK","REGION_TOK","RESUME_TOK","RND_TOK","ROOT_TOK",
"SET_TOK","SUBTITLE_TOK","TAIL_TOK","TITLE_TOK","TITLESET_TOK","TOP_TOK",
"UP_TOK","VMGM_TOK","_OR_TOK","XOR_TOK","LOR_TOK","BOR_TOK","_AND_TOK",
"LAND_TOK","BAND_TOK","NOT_TOK","EQ_TOK","NE_TOK","GE_TOK","GT_TOK","LE_TOK",
"LT_TOK","ADD_TOK","SUB_TOK","MUL_TOK","DIV_TOK","MOD_TOK","ADDSET_TOK",
"SUBSET_TOK","MULSET_TOK","DIVSET_TOK","MODSET_TOK","ANDSET_TOK","ORSET_TOK",
"XORSET_TOK","SEMICOLON_TOK","COLON_TOK","ERROR_TOK",
};
static const char *yyrule[] = {
"$accept : finalparse",
"finalparse : statements",
"statements : statement",
"statements : statement statements",
"statement : jumpstatement",
"statement : callstatement",
"statement : EXIT_TOK SEMICOLON_TOK",
"statement : RESUME_TOK SEMICOLON_TOK",
"statement : GOTO_TOK ID_TOK SEMICOLON_TOK",
"statement : ID_TOK COLON_TOK",
"statement : BREAK_TOK SEMICOLON_TOK",
"statement : setstatement",
"statement : OPENBRACE_TOK statements CLOSEBRACE_TOK",
"statement : ifelsestatement",
"jtsl : TITLESET_TOK NUM_TOK",
"jtsl : VMGM_TOK",
"jtsl :",
"jtml : MENU_TOK NUM_TOK",
"jtml : MENU_TOK",
"jtml : MENU_TOK ENTRY_TOK TITLE_TOK",
"jtml : MENU_TOK ENTRY_TOK ROOT_TOK",
"jtml : MENU_TOK ENTRY_TOK SUBTITLE_TOK",
"jtml : MENU_TOK ENTRY_TOK AUDIO_TOK",
"jtml : MENU_TOK ENTRY_TOK ANGLE_TOK",
"jtml : MENU_TOK ENTRY_TOK PTT_TOK",
"jtml : FPC_TOK",
"jtml : TITLE_TOK NUM_TOK",
"jtml :",
"jcl : CHAPTER_TOK NUM_TOK",
"jcl :",
"jumpstatement : JUMP_TOK jtsl jtml jcl SEMICOLON_TOK",
"jumpstatement : JUMP_TOK CELL_TOK NUM_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PROGRAM_TOK NUM_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK CELL_TOK TOP_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK NEXT_TOK CELL_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PREV_TOK CELL_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PROGRAM_TOK TOP_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK NEXT_TOK PROGRAM_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PREV_TOK PROGRAM_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PGC_TOK TOP_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK NEXT_TOK PGC_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PREV_TOK PGC_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK UP_TOK PGC_TOK SEMICOLON_TOK",
"jumpstatement : JUMP_TOK PGC_TOK TAIL_TOK SEMICOLON_TOK",
"resumel : RESUME_TOK NUM_TOK",
"resumel :",
"lastmenu : LAST_TOK MENU_TOK",
"lastmenu :",
"callstatement : CALL_TOK jtsl jtml jcl resumel lastmenu SEMICOLON_TOK",
"reg : G_TOK",
"reg : S_TOK",
"reg : AUDIO_TOK",
"reg : SUBTITLE_TOK",
"reg : ANGLE_TOK",
"reg : BUTTON_TOK",
"reg : REGION_TOK",
"regornum : reg",
"regornum : NUM_TOK",
"expression : OPENPAREN_TOK expression CLOSEPAREN_TOK",
"expression : regornum",
"expression : expression ADD_TOK expression",
"expression : expression SUB_TOK expression",
"expression : expression MUL_TOK expression",
"expression : expression DIV_TOK expression",
"expression : expression MOD_TOK expression",
"expression : expression BAND_TOK expression",
"expression : expression BOR_TOK expression",
"expression : expression _AND_TOK expression",
"expression : expression _OR_TOK expression",
"expression : expression XOR_TOK expression",
"expression : RND_TOK OPENPAREN_TOK expression CLOSEPAREN_TOK",
"boolexpr : OPENPAREN_TOK boolexpr CLOSEPAREN_TOK",
"boolexpr : expression EQ_TOK expression",
"boolexpr : expression NE_TOK expression",
"boolexpr : expression GE_TOK expression",
"boolexpr : expression GT_TOK expression",
"boolexpr : expression LE_TOK expression",
"boolexpr : expression LT_TOK expression",
"boolexpr : boolexpr LOR_TOK boolexpr",
"boolexpr : boolexpr LAND_TOK boolexpr",
"boolexpr : boolexpr _OR_TOK boolexpr",
"boolexpr : boolexpr _AND_TOK boolexpr",
"boolexpr : NOT_TOK boolexpr",
"regorcounter : reg",
"regorcounter : COUNTER_TOK G_TOK",
"setstatement : regorcounter SET_TOK expression SEMICOLON_TOK",
"setstatement : reg ADDSET_TOK expression SEMICOLON_TOK",
"setstatement : reg SUBSET_TOK expression SEMICOLON_TOK",
"setstatement : reg MULSET_TOK expression SEMICOLON_TOK",
"setstatement : reg DIVSET_TOK expression SEMICOLON_TOK",
"setstatement : reg MODSET_TOK expression SEMICOLON_TOK",
"setstatement : reg ANDSET_TOK expression SEMICOLON_TOK",
"setstatement : reg ORSET_TOK expression SEMICOLON_TOK",
"setstatement : reg XORSET_TOK expression SEMICOLON_TOK",
"ifstatement : IF_TOK OPENPAREN_TOK boolexpr CLOSEPAREN_TOK statement",
"ifelsestatement : ifstatement",
"ifelsestatement : ifstatement ELSE_TOK statement",

};
#endif
/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static YYSTACKDATA yystack;

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (short *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 103 "dvdvmy.y"
	{
    dvd_vm_parsed_cmd=yyval.statement;
}
break;
case 2:
#line 108 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 3:
#line 111 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-1].statement;
    yyval.statement->next=yystack.l_mark[0].statement;
}
break;
case 4:
#line 117 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 5:
#line 120 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 6:
#line 123 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_EXIT;
}
break;
case 7:
#line 127 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=16;
}
break;
case 8:
#line 132 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_GOTO;
    yyval.statement->s1=yystack.l_mark[-1].str_val;
}
break;
case 9:
#line 137 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LABEL;
    yyval.statement->s1=yystack.l_mark[-1].str_val;
}
break;
case 10:
#line 142 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_BREAK;
}
break;
case 11:
#line 146 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 12:
#line 149 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-1].statement;
}
break;
case 13:
#line 152 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 14:
#line 157 "dvdvmy.y"
	{
    yyval.int_val=(yystack.l_mark[0].int_val)+1;
}
break;
case 15:
#line 160 "dvdvmy.y"
	{
    yyval.int_val=1;
}
break;
case 16:
#line 163 "dvdvmy.y"
	{
    yyval.int_val=0;
}
break;
case 17:
#line 168 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 18:
#line 171 "dvdvmy.y"
	{
    yyval.int_val=120; /* default entry*/
}
break;
case 19:
#line 174 "dvdvmy.y"
	{
    yyval.int_val=122;
}
break;
case 20:
#line 177 "dvdvmy.y"
	{
    yyval.int_val=123;
}
break;
case 21:
#line 180 "dvdvmy.y"
	{
    yyval.int_val=124;
}
break;
case 22:
#line 183 "dvdvmy.y"
	{
    yyval.int_val=125;
}
break;
case 23:
#line 186 "dvdvmy.y"
	{
    yyval.int_val=126;
}
break;
case 24:
#line 189 "dvdvmy.y"
	{
    yyval.int_val=127;
}
break;
case 25:
#line 192 "dvdvmy.y"
	{
    yyval.int_val=121;
}
break;
case 26:
#line 195 "dvdvmy.y"
	{
    yyval.int_val=(yystack.l_mark[0].int_val)|128;
}
break;
case 27:
#line 198 "dvdvmy.y"
	{
    yyval.int_val=0;
}
break;
case 28:
#line 203 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 29:
#line 206 "dvdvmy.y"
	{
    yyval.int_val=0;
}
break;
case 30:
#line 211 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_JUMP;
    yyval.statement->i1=yystack.l_mark[-3].int_val;
    yyval.statement->i2=yystack.l_mark[-2].int_val;
    yyval.statement->i3=yystack.l_mark[-1].int_val;
}
break;
case 31:
#line 218 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_JUMP;
    yyval.statement->i3=2*65536+yystack.l_mark[-1].int_val;
}
break;
case 32:
#line 223 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_JUMP;
    yyval.statement->i3=65536+yystack.l_mark[-1].int_val;
}
break;
case 33:
#line 228 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=1;
}
break;
case 34:
#line 233 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=2;
}
break;
case 35:
#line 238 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=3;
}
break;
case 36:
#line 243 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=5;
}
break;
case 37:
#line 248 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=6;
}
break;
case 38:
#line 253 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=7;
}
break;
case 39:
#line 258 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=9;
}
break;
case 40:
#line 263 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=10;
}
break;
case 41:
#line 268 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=11;
}
break;
case 42:
#line 273 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=12;
}
break;
case 43:
#line 278 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_LINK;
    yyval.statement->i1=13;
}
break;
case 44:
#line 285 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 45:
#line 288 "dvdvmy.y"
	{
    yyval.int_val=0;
}
break;
case 46:
#line 293 "dvdvmy.y"
	{
    yyval.int_val=1;
}
break;
case 47:
#line 296 "dvdvmy.y"
	{
    yyval.int_val=0;
}
break;
case 48:
#line 301 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_CALL;
    yyval.statement->i1=yystack.l_mark[-5].int_val;
    yyval.statement->i2=yystack.l_mark[-4].int_val;
    yyval.statement->i3=yystack.l_mark[-3].int_val;
    yyval.statement->i4=yystack.l_mark[-2].int_val;
    yyval.statement->i5=yystack.l_mark[-1].int_val;
}
break;
case 49:
#line 312 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 50:
#line 315 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val+0x80;
}
break;
case 51:
#line 318 "dvdvmy.y"
	{
    yyval.int_val=0x81;
}
break;
case 52:
#line 321 "dvdvmy.y"
	{
    yyval.int_val=0x82;
}
break;
case 53:
#line 324 "dvdvmy.y"
	{
    yyval.int_val=0x83;
}
break;
case 54:
#line 327 "dvdvmy.y"
	{
    yyval.int_val=0x88;
}
break;
case 55:
#line 330 "dvdvmy.y"
	{
    yyval.int_val=0x80+20;
}
break;
case 56:
#line 335 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val-256;
}
break;
case 57:
#line 338 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 58:
#line 343 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-1].statement;
}
break;
case 59:
#line 346 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_VAL;
    yyval.statement->i1=yystack.l_mark[0].int_val;
}
break;
case 60:
#line 351 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_ADD,yystack.l_mark[0].statement);
}
break;
case 61:
#line 354 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_SUB,yystack.l_mark[0].statement);
}
break;
case 62:
#line 357 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_MUL,yystack.l_mark[0].statement);
}
break;
case 63:
#line 360 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_DIV,yystack.l_mark[0].statement);
}
break;
case 64:
#line 363 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_MOD,yystack.l_mark[0].statement);
}
break;
case 65:
#line 366 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_AND,yystack.l_mark[0].statement);
}
break;
case 66:
#line 369 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_OR, yystack.l_mark[0].statement);
}
break;
case 67:
#line 372 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_AND,yystack.l_mark[0].statement);
}
break;
case 68:
#line 375 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_OR, yystack.l_mark[0].statement);
}
break;
case 69:
#line 378 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_XOR,yystack.l_mark[0].statement);
}
break;
case 70:
#line 381 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_RND;
    yyval.statement->param=yystack.l_mark[-1].statement;
}
break;
case 71:
#line 388 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-1].statement;
}
break;
case 72:
#line 391 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_EQ,yystack.l_mark[0].statement);
}
break;
case 73:
#line 394 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_NE,yystack.l_mark[0].statement);
}
break;
case 74:
#line 397 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_GTE,yystack.l_mark[0].statement);
}
break;
case 75:
#line 400 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_GT,yystack.l_mark[0].statement);
}
break;
case 76:
#line 403 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LTE,yystack.l_mark[0].statement);
}
break;
case 77:
#line 406 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LT,yystack.l_mark[0].statement);
}
break;
case 78:
#line 409 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LOR,yystack.l_mark[0].statement);
}
break;
case 79:
#line 412 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LAND,yystack.l_mark[0].statement);
}
break;
case 80:
#line 415 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LOR,yystack.l_mark[0].statement);
}
break;
case 81:
#line 418 "dvdvmy.y"
	{
    yyval.statement=statement_expression(yystack.l_mark[-2].statement,VM_LAND,yystack.l_mark[0].statement);
}
break;
case 82:
#line 421 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_NOT;
    yyval.statement->param=yystack.l_mark[0].statement;
}
break;
case 83:
#line 428 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val;
}
break;
case 84:
#line 431 "dvdvmy.y"
	{
    yyval.int_val=yystack.l_mark[0].int_val+0x20;
}
break;
case 85:
#line 436 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_SET;
    yyval.statement->i1=yystack.l_mark[-3].int_val;
    yyval.statement->param=yystack.l_mark[-1].statement;
}
break;
case 86:
#line 442 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_ADD,yystack.l_mark[-1].statement);
}
break;
case 87:
#line 445 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_SUB,yystack.l_mark[-1].statement);
}
break;
case 88:
#line 448 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_MUL,yystack.l_mark[-1].statement);
}
break;
case 89:
#line 451 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_DIV,yystack.l_mark[-1].statement);
}
break;
case 90:
#line 454 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_MOD,yystack.l_mark[-1].statement);
}
break;
case 91:
#line 457 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_AND,yystack.l_mark[-1].statement);
}
break;
case 92:
#line 460 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_OR,yystack.l_mark[-1].statement);
}
break;
case 93:
#line 463 "dvdvmy.y"
	{
    yyval.statement=statement_setop(yystack.l_mark[-3].int_val,VM_XOR,yystack.l_mark[-1].statement);
}
break;
case 94:
#line 468 "dvdvmy.y"
	{
    yyval.statement=statement_new();
    yyval.statement->op=VM_IF;
    yyval.statement->param=yystack.l_mark[-2].statement;
    yystack.l_mark[-2].statement->next=statement_new();
    yystack.l_mark[-2].statement->next->op=VM_IF;
    yystack.l_mark[-2].statement->next->param=yystack.l_mark[0].statement;
}
break;
case 95:
#line 478 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[0].statement;
}
break;
case 96:
#line 481 "dvdvmy.y"
	{
    yyval.statement=yystack.l_mark[-2].statement;
    yyval.statement->param->next->next=yystack.l_mark[0].statement;
}
break;
#line 1484 "dvdvmy.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
